---
title: AddressErrors
slug: Web/API/AddressErrors
tags:
  - API
  - Address
  - AddressErrors
  - Dictionary
  - Errors
  - Interface
  - Payment Address
  - Payment Request
  - Payment Request API
  - Reference
  - payment
  - paymentAddress
---
<div>{{APIRef("Payment Request API")}}</div>

<p><span class="seoSummary">The <strong><code>AddressErrors</code></strong> dictionary is used by the <a href="/en-US/docs/Web/API/Payment_Request_API">Payment Request API</a> to report validation errors in a physical address (typically a billing address or a shipping address).</span> Any members which is present indicates that a validation error occurred for the member of the same name in an address described using {{domxref("PaymentAddress")}}.</p>

<p><code>AddressErrors</code> is the type of the object returned by {{domxref("PaymentDetailsUpdate.shippingAddressErrors", "shippingAddressErrors")}} in the {{domxref("PaymentDetailsUpdate")}} passed into {{domxref("PaymentRequestUpdateEvent.updateWith()")}} by the {{event("shippingaddresschange")}} event handler if a change to the address resulted in a validation error occurring.</p>

<p>See the {{anch("Examples", "examples below")}} to see how this works.</p>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("AddressErrors.addressLine", "addressLine")}}</dt>
 <dd>A {{domxref("DOMString")}} which, if present, indicates that the {{domxref("PaymentAddress.addressLine", "addressLine")}} property of the {{domxref("PaymentAddress")}} could not be validated. The contents of the string provide a human-readable explanation of the validation failure, and ideally suggestions to correct the problem.</dd>
 <dt>{{domxref("AddressErrors.city", "city")}}</dt>
 <dd>A {{domxref("DOMString")}} which, if present, indicates that the {{domxref("PaymentAddress.city", "city")}} property of the {{domxref("PaymentAddress")}} could not be validated. The contents of the string provide a human-readable explanation of the validation failure, and ideally suggestions to correct the problem.</dd>
 <dt>{{domxref("AddressErrors.country", "country")}}</dt>
 <dd>A {{domxref("DOMString")}} which, if present, indicates that the {{domxref("PaymentAddress.country", "country")}} property of the {{domxref("PaymentAddress")}} could not be validated. The contents of the string provide a human-readable explanation of the validation failure, and ideally suggestions to correct the problem.</dd>
 <dt>{{domxref("AddressErrors.dependentLocality", "dependentLocality")}}</dt>
 <dd>A {{domxref("DOMString")}} which, if present, indicates that the {{domxref("PaymentAddress.dependentLocality", "dependentLocality")}} property of the {{domxref("PaymentAddress")}} could not be validated. The contents of the string provide a human-readable explanation of the validation failure, and ideally suggestions to correct the problem.</dd>
 <dt>{{domxref("AddressErrors.organization", "organization")}}</dt>
 <dd>A {{domxref("DOMString")}} which, if present, indicates that the {{domxref("PaymentAddress.organization", "organization")}} property of the {{domxref("PaymentAddress")}} could not be validated. The contents of the string provide a human-readable explanation of the validation failure, and ideally suggestions to correct the problem.</dd>
 <dt>{{domxref("AddressErrors.phone", "phone")}}</dt>
 <dd>A {{domxref("DOMString")}} which, if present, indicates that the {{domxref("PaymentAddress.phone", "phone")}} property of the {{domxref("PaymentAddress")}} could not be validated. The contents of the string provide a human-readable explanation of the validation failure, and ideally suggestions to correct the problem.</dd>
 <dt>{{domxref("AddressErrors.postalCode", "postalCode")}}</dt>
 <dd>A {{domxref("DOMString")}} which, if present, indicates that the {{domxref("PaymentAddress.postalCode", "postalCode")}} property of the {{domxref("PaymentAddress")}} could not be validated. The contents of the string provide a human-readable explanation of the validation failure, and ideally suggestions to correct the problem.</dd>
 <dt>{{domxref("AddressErrors.recipient", "recipient")}}</dt>
 <dd>A {{domxref("DOMString")}} which, if present, indicates that the {{domxref("PaymentAddress.recipient", "recipient")}} property of the {{domxref("PaymentAddress")}} could not be validated. The contents of the string provide a human-readable explanation of the validation failure, and ideally suggestions to correct the problem.</dd>
 <dt>{{domxref("AddressErrors.region", "region")}}</dt>
 <dd>A {{domxref("DOMString")}} which, if present, indicates that the {{domxref("PaymentAddress.region", "region")}} property of the {{domxref("PaymentAddress")}} could not be validated. The contents of the string provide a human-readable explanation of the validation failure, and ideally suggestions to correct the problem.</dd>
 <dt>{{domxref("AddressErrors.regionCode", "regionCode")}}</dt>
 <dd>A {{domxref("DOMString")}} which, if present, indicates that the {{domxref("PaymentAddress.regionCode", "regionCode")}} property of the {{domxref("PaymentAddress")}} could not be validated. The contents of the string provide a human-readable explanation of the validation failure, and ideally suggestions to correct the problem.</dd>
 <dt>{{domxref("AddressErrors.sortingCode", "sortingCode")}}</dt>
 <dd>A {{domxref("DOMString")}} which, if present, indicates that the {{domxref("PaymentAddress.sortingCode", "sortingCode")}} property of the {{domxref("PaymentAddress")}} could not be validated. The contents of the string provide a human-readable explanation of the validation failure, and ideally suggestions to correct the problem.</dd>
</dl>

<h3 id="Obsolete_properties">Obsolete properties</h3>

<p>These properties have been removed from the specification and should no longer be used.</p>

<dl>
 <dt>{{domxref("AddressErrors.languageCode", "languageCode")}} {{deprecated_inline}}</dt>
 <dd>A {{domxref("DOMString")}} which, if present, indicates that the {{domxref("PaymentAddress.languageCode", "languageCode")}} property of the {{domxref("PaymentAddress")}} could not be validated. The contents of the string provide a human-readable explanation of the validation failure, and ideally suggestions to correct the problem.</dd>
</dl>

<h2 id="Usage_notes">Usage notes</h2>

<p>Keep in mind that some violation errors may be outside the ability of the user to fix. Try to avoid asking the user to make corrections to things they can't change, and there may be situations in which you need to allow validation errors to be accepted anyway (for example, if you validate addresses against a postal service database and a new home has been built and its address is not yet in the database).</p>

<h2 id="Examples">Examples</h2>

<h3 id="Snippet_Limiting_destination_countries">Snippet: Limiting destination countries</h3>

<p>This first example is just a snippet showing an implementation of the event handler for the {{event("shippingaddresschange")}} event which checks to be sure the chosen address is located within one of a limited number of countries.</p>

<pre class="brush: js">function handleAddressChange(ev) {
  const validCountries = ["US", "CA", "GB", "JP", "CN", "MX"];

  const genericAddressError = "Unable to ship to the given address. Please check for any errors.";
  const invalidCountryError = "At this time, we only ship to the United States, Canada, Great Britain, Japan, China, and Germany.";

  let shippingAddress = ev.target.shippingAddress;
  let shippingAddressErrors = {};
  let updateDetails = {};

  if (!validCountries.includes(shippingAddress.country)) {
    ev.target.shippingOptions = [];
    shippingAddressErrors.country = invalidCountryError;

    updateDetails = {
      error: genericAddressError,
      shippingAddressErrors,
      ...defaultPaymentDetails
    };
  }

  ev.updateWith(updateDetails);
}</pre>

<p>See {{anch("Handling address changes")}} for a description of how this code works.</p>

<h3 id="Complete_example">Complete example</h3>

<p>Here we'll see a complete, working version of the example above (except of course that it's not connected to an actual payment handler, so no payments are actually processed). In the example, we're handling a donation to an organization that will be sending a "thank you" gift to the donor, so it requests shipping information along with allowing the donation payment itself.</p>

<h4 id="JavaScript">JavaScript</h4>

<h5 id="Payment_Request_data">Payment Request data</h5>

<p>First, we declare the variables <code>supportedHandlers</code>, which is compatible with {{domxref("PaymentMethodData")}}, and <code>defaultPaymentDetails</code>, which is a {{domxref("PaymentDetailsUpdate")}} object.</p>

<pre class="brush: js">let supportedHandlers = [
  {
    supportedMethods: "basic-card",
    data: {
      supportedNetworks: ["visa", "mastercard", "amex", "discover"],
      supportedTypes: ["credit", "debit"]
    }
  }
];

let defaultPaymentDetails = {
  total: {label: 'Donation', amount: {currency: 'USD', value: '65.00'}},
  displayItems: [
    {
      label: 'Original donation amount',
      amount: {currency: 'USD', value: '65.00'}
    }
  ],
  shippingOptions: [
    {
      id: 'standard',
      label: 'Standard shipping',
      amount: {currency: 'USD', value: '0.00'},
      selected: true
    }
  ]
};</pre>

<p><code>supportedHandlers</code> describes the supported payment handlers and the details for those. In this example, only the Basic Card handler is supported, and it's configured to permit both debit and credit cards from Visa, Master Card, American Express, and Discover.</p>

<p><code>defaultPaymentDetails</code> describes the payment being requested. A description of the total amount being requested (including a label and the currency used), a list of the line items (in this case only one, "Original donation amount"), and a list of shipping options available; in this case only one.</p>

<h5 id="Process_the_payment">Process the payment</h5>

<p>The main payment processing code is found in the <code>process()</code> method, up next.</p>

<pre class="brush: js">let request;

function process() {
  let options = {requestShipping: true};

  try {
    request = new PaymentRequest(supportedHandlers, defaultPaymentDetails, options);
    // Add event listeners here.
    request.onshippingaddresschange = handleAddressChange;
    // Call show() to trigger the browser's payment flow.
    request.show().then(function(instrumentResponse) {
      // Do something with the response from the UI.
      console.log("Got response!");
    })
    .catch(function(err) {
      // Do something with the error from request.show().
      console.error(`Error from show(): ${err}`);
    });
  } catch (e) {
    // Catch any errors from trying to create the PaymentRequest object.
  }
}</pre>

<p>This code creates a new {{domxref("PaymentRequest")}}, providing the supported handlers and payment options we set up above, as well as additional options (in this case, that we want to ask for shipping information).</p>

<p>After that, we set up the handler for the {{event("shippingaddresschange")}} event so we can validate address information and call the request's {{domxref("PaymentRequest.show", "show()")}} method to start running the payment UI.</p>

<h5 id="Handling_address_changes">Handling address changes</h5>

<p>The <code>handleAddressChange()</code> method, called when <code>shippingaddresschange</code> events occur, is where we'll look to see if the country is one of those we allow as shipping destinations.</p>

<pre class="brush: js">function handleAddressChange(ev) {
  const validCountries = ["US", "CA", "GB", "JP", "CN", "MX"];

  const genericAddressError = "Unable to ship to the given address. Please check for any errors.";
  const invalidCountryError = "At this time, we only ship to the United States, Canada, Great Britain, Japan, China, and Germany.";

  let shippingAddress = ev.target.shippingAddress;
  let shippingAddressErrors = {};
  let updateDetails = {};

  if (!validCountries.includes(shippingAddress.country)) {
    ev.target.shippingOptions = [];
    shippingAddressErrors.country = invalidCountryError;

    updateDetails = {
      error: genericAddressError,
      shippingAddressErrors,
      ...defaultPaymentDetails
    };
  }

  ev.updateWith(updateDetails);
}</pre>

<p>The <code>shippingaddresschange</code> event doesn't receive the {{domxref("PaymentRequest")}} object directly, so we fetch it from the {{domxref("Event.target", "target")}} property of the event. If the request's {{domxref("PaymentRequest.shippingAddress", "shippingAddress")}} has a value for {{domxref("PaymentAddress.country", "country")}} which isn't in the array <code>validCountries</code>, we generate the error.</p>

<p>That's done by removing all shipping options currently set on the request, then set up an object named <code>shippingAddressErrors</code> which contains a <code>country</code> property which is an error message describing why the stated country isn't being permitted as a value.</p>

<p>Then a {{domxref("PaymentDetailsUpdate")}} object is created with its {{domxref("PaymentDetailsUpdate.error", "error")}} set to a generic message about address errors and with the reset of the object's values taken from <code>shippingAddressErrors</code>, and, using "<code>...defaultPaymentDetails</code>" as the final entry in the object, the remeainder of the properties' values are taken from <code>defaultPaymentDetails</code>.</p>

<p>The final step is to call the event's {{domxref("PaymentRequestUpdateEvent.updateWith", "updateWith()")}} method, passing along the <code>updateDetails</code> object. This lets the Payment Request API know to present the specified error or errors but to allow the user to keep trying to edit the address.</p>

<h5 id="Setting_up_the_Donate_Now_button">Setting up the Donate Now button</h5>

<p>This code creates a handler for the {{event("load")}} event on the {{domxref("Window", "window")}} which in turn adds the needed {{event("click")}} event handler to the "Donate Now" button so that clicking it starts the payment process.</p>

<pre class="brush: js">window.addEventListener("load", function(ev) {
  document.getElementById("pay").addEventListener("click", process, false);
}, false);
</pre>

<p>See {{domxref("EventTarget.addEventListener", "addEventListener()")}}  for information about event handlers and how they work.</p>

<h4 id="HTML">HTML</h4>

<p>Here's the simple HTML for this example.</p>

<pre class="brush: html">&lt;p&gt;Donate US $65 to our worthwhile cause and we will send you a totally
not-useless gift as a token of our thanks!&lt;/p&gt;
&lt;button id="pay"&gt;Donate Now&lt;/button&gt;</pre>

<h4 id="Result">Result</h4>

<p>The final product is below.</p>

<div class="note">
<p><strong>Note:</strong> if you have content blocking features enabled in your browser, the example may not work inline below. In that case, you can {{LiveSampleLink("Complete_example", "view the example on its own page")}}.</p>
</div>

<p>{{EmbedLiveSample("Complete_example", 640, 400)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Payment','#dom-addresserrors','AddressErrors')}}</td>
   <td>{{Spec2('Payment')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.AddressErrors")}}</p>
</div>
